﻿#target "Illustrator"

/**
  * ver0.2 14/11/29
  * 封筒・紙袋通販.com
  * https://www.futo-kamibukuro.com
  * GUI色指定対応版。
 **/

/**
  * カラーピッカー調べ　※今後変更の可能性があります。
 **/
var cmykPaperColor='0:0:0:0';
var paperColorDictionary = {
	'パステルホワイト':{'RGB16':'f9f8fd','RGB10':'249:248:253','CMYK10':'3:3:0:0','iro':'pastelWhite'},
	'パステルサクラ':{'RGB16':'fce8f3','RGB10':'252:232:243','CMYK10':'1:14:0:0','iro':'pastelSukura'},
	'パステルピンク':{'RGB16':'fcd5cb','RGB10':'252:213:203','CMYK10':'1:24:17:0','iro':'pastelPink'},
	'パステルベージュ':{'RGB16':'f3d9c0','RGB10':'243:217:192','CMYK10':'6:19:25:0','iro':'pastelBeijyu'},
	'パステルウスクリーム':{'RGB16':'FFF8E5','RGB10':'253:248:225','CMYK10':'2:3:16:0','iro':'pastelCleam'},
	'パステルクリーム':{'RGB16':'fdf1c1','RGB10':'253:241:193','CMYK10':'3:7:31:0','iro':'pastelUsucleam'},
	'パステルオレンジ':{'RGB16':'fcd490','RGB10':'252:212:144','CMYK10':'3:22:48:0','iro':'pastelOrange'},
	'パステルサーモン':{'RGB16':'c9a9b0','RGB10':'201:169:176','CMYK10':'26:38:23:0','iro':'pastelSamon'},
	'パステルフジ':{'RGB16':'c2c0db','RGB10':'194:192:219','CMYK10':'28:24:5:0','iro':'pastelFuji'},
	'パステルスカイ':{'RGB16':'d9e9fb','RGB10':'217:233:251','CMYK10':'18:6:0:0','iro':'pastelSky'},
	'パステルブルー':{'RGB16':'c9eafb','RGB10':'201:234:251','CMYK10':'25:1:2:0','iro':'pastelBlue'},
	'パステルアクア':{'RGB16':'bfd1fb','RGB10':'191:209:251','CMYK10':'29:16:0:0','iro':'pastelAqua'},
	'パステルグリーン':{'RGB16':'c5e8d8','RGB10':'197:232:216','CMYK10':'28:0:21:0','iro':'pastelGreen'},
	'パステルウグイス':{'RGB16':'e8f8c8','RGB10':'232:248:200','CMYK10':'14:0:30:0','iro':'pastelUguisu'},
	'パステルシルバー':{'RGB16':'ced0dc','RGB10':'206:208:220','CMYK10':'23:17:9:0','iro':'pastelSilver'},
	'パステルメタル':{'RGB16':'c8d6e0','RGB10':'200:214:224','CMYK10':'26:12:10:0','iro':'pastelMetal'},
	'パステルグレー':{'RGB16':'d0d1c9','RGB10':'208:209:201','CMYK10':'22:16:21:0','iro':'pastelGray'},
	'パステルアビス':{'RGB16':'98a8b5','RGB10':'152:168:181','CMYK10':'47:30:24:0','iro':'pastelAbis'},
	'パステルネイビー':{'RGB16':'371457','RGB10':'55:20:87','CMYK10':'92:100:58:14','iro':'pastelNavy'},
	'パステルブラック':{'RGB16':'2f3738','RGB10':'47:55:56','CMYK10':'82:72:70:42','iro':'pastelBlack'},
	'カラーホワイト':{'RGB16':'f7f0e8','RGB10':'247:240:232','CMYK10':'4:7:10:0','iro':'colorWhite'},
	'カラーアイボリー':{'RGB16':'f8f5d1','RGB10':'248:245:209','CMYK10':'6:3:24:0','iro':'colorIvory'},
	'カラークリーム':{'RGB16':'f0dd91','RGB10':'240:221:145','CMYK10':'11:15:50:0','iro':'colorCleam'},
	'カラーイエロー':{'RGB16':'f8db50','RGB10':'248:219:80','CMYK10':'8:16:74:0','iro':'colorYellow'},
	'カラーオレンジ':{'RGB16':'fcb058','RGB10':'252:176:88','CMYK10':'2:41:68:0','iro':'colorOrange'},
	'カラーグレー':{'RGB16':'a9b1a9','RGB10':'169:177:169','CMYK10':'40:26:38:0','iro':'colorGray'},
	'カラーシルバー':{'RGB16':'f3f1dc','RGB10':'243:241:220','CMYK10':'7:5:17:0','iro':'colorSilver'},
	'カラーピンク':{'RGB16':'fce8f3','RGB10':'252:232:243','CMYK10':'1:14:0:0','iro':'colorPink'},
	'カラースカイ':{'RGB16':'d3d4e8','RGB10':'211:212:232','CMYK10':'21:16:3:0','iro':'colorSky'},
	'カラーソライロ':{'RGB16':'a1d0ea','RGB10':'161:208:234','CMYK10':'41:9:7:0','iro':'colorSorairo'},
	'カラーブルー':{'RGB16':'4889c8','RGB10':'72:137:200','CMYK10':'73:41:7:0','iro':'colorBlue'},
	'カラーエメラルド':{'RGB16':'77c2a0','RGB10':'119:194:160','CMYK10':'57:6:47:0','iro':'colorEmerald'},
	'カラーミズイロ':{'RGB16':'cdece8','RGB10':'205:236:232','CMYK10':'24:0:13:0','iro':'colorMizuiro'},
	'カラーウグイス':{'RGB16':'d0edb7','RGB10':'208:237:183','CMYK10':'25:0:37:0','iro':'colorUguisu'},
	'カラーグリーン':{'RGB16':'99c964','RGB10':'153:201:100','CMYK10':'48:6:73:0','iro':'colorGreen'},
	'カラーレッド':{'RGB16':'c8404f','RGB10':'200:64:79','CMYK10':'27:87:62:0','iro':'colorRed'},
	'カラーブラック':{'RGB16':'2a2f2f','RGB10':'42:47:47','CMYK10':'82:74:73:49','iro':'colorBlack'},
	'色上レモン':{'RGB16':'f2e8b6','RGB10':'242:232:182','CMYK10':'9:9:35:0','iro':'irojyoLemon'},
	'色上アイボリー':{'RGB16':'ede3c1','RGB10':'237:227:193','CMYK10':'10:11:28:0','iro':'irojyoIvory'},
	'色上肌':{'RGB16':'e8daab','RGB10':'232:218:171','CMYK10':'13:15:38:0','iro':'irojyoHada'},
	'色上白茶':{'RGB16':'d8c380','RGB10':'21:24:56:0','CMYK10':'21:24:56:0','iro':'irojyoShirotya'},
	'色上クリーム':{'RGB16':'e9d989','RGB10':'233:217:137','CMYK10':'14:15:53:0','iro':'irojyoCleam'},
	'色上濃クリーム':{'RGB16':'ebd45b','RGB10':'235:212:91','CMYK10':'14:17:71:0','iro':'irojyoKoiCleam'},
	'色上やまぶき':{'RGB16':'f4f478','RGB10':'244:244:120','CMYK10':'11:0:62:0','iro':'irojyoYamabuki'},
	'色上黄':{'RGB16':'e0e158','RGB10':'224:225:88','CMYK10':'20:7:74:0','iro':'irojyoYellow'},
	'色上もえぎ':{'RGB16':'c8e071','RGB10':'200:224:113','CMYK10':'31:2:66:0','iro':'irojyoMoegi'},
	'色上みどり':{'RGB16':'a0d15d','RGB10':'160:209:93','CMYK10':'45:2:76:0','iro':'irojyoGreen'},
	'色上若竹':{'RGB16':'7cc888','RGB10':'124:200:136','CMYK10':'56:2:59:0','iro':'irojyoWakatake'},
	'色上鶯':{'RGB16':'badd93','RGB10':'186:221:147','CMYK10':'35:2:53:0','iro':'irojyoUguisu'},
	'色上若草':{'RGB16':'d3e9bb','RGB10':'211:233:187','CMYK10':'23:1:35:0','iro':'irojyoWakakusa'},
	'色上浅黄':{'RGB16':'baddd1','RGB10':'186:221:209','CMYK10':'33:4:23:0','iro':'irojyoAsagi'},
	'色上水':{'RGB16':'c0dee8','RGB10':'192:222:232','CMYK10':'29:6:10:0','iro':'irojyoMizu'},
	'色上空':{'RGB16':'a2cbe0','RGB10':'162:203:224','CMYK10':'41:12:11:0','iro':'irojyoSora'},
	'色上ブルー':{'RGB16':'77a4c9','RGB10':'119:164:201','CMYK10':'58:29:14:0','iro':'irojyoBlue'},
	'色上うす水':{'RGB16':'cddad0','RGB10':'205:218:208','CMYK10':'24:10:20:0','iro':'irojyoUsumizu'},
	'色上あじさい':{'RGB16':'d3dbe3','RGB10':'211:219:227','CMYK10':'21:12:9:0','iro':'irojyoAjisai'},
	'色上ラベンダー':{'RGB16':'e0dbe4','RGB10':'224:219:228','CMYK10':'14:14:7:0','iro':'irojyoLavender'},
	'色上藤':{'RGB16':'cac8d5','RGB10':'202:200:213','CMYK10':'24:21:11:0','iro':'irojyoFuji'},
	'色上りんどう':{'RGB16':'c3a8d3','RGB10':'195:168:211','CMYK10':'29:38:1:0','iro':'irojyoRindou'},
	'色上さくら':{'RGB16':'f5ddd8','RGB10':'245:221:216','CMYK10':'4:13:13:0','iro':'irojyoSakura'},
	'色上コスモス':{'RGB16':'f2d2d8','RGB10':'242:210:216','CMYK10':'6:24:9:0','iro':'irojyoCosmos '},
	'色上桃':{'RGB16':'edc0ba','RGB10':'237:192:186','CMYK10':'8:32:22:0','iro':'irojyoMomo'},
	'色上サーモン':{'RGB16':'f9a390','RGB10':'249:163:144','CMYK10':'80:28:48:0','iro':'irojyoSamon'},
	'色上びわ':{'RGB16':'f5d1a0','RGB10':'245:209:160','CMYK10':'6:28:40:0','iro':'irojyoBiwa'},
	'色上オレンジ':{'RGB16':'f2ab5a','RGB10':'242:171:90','CMYK10':'7:42:67:0','iro':'irojyoOrange'},
	'色上アマリリス':{'RGB16':'f09468','RGB10':'240:148:104','CMYK10':'7:53:58:0','iro':'irojyoAmaryllis'},
	'色上赤':{'RGB16':'d0535e','RGB10':'208:83:94','CMYK10':'23:80:54:0','iro':'irojyoRed'},
	'色上白':{'RGB16':'FFFFFF','RGB10':'224:228:232','CMYK10':'15:9:7:0','iro':'irojyoWhite'},
	'色上銀ねず':{'RGB16':'a9b3ab','RGB10':'169:179:171','CMYK10':'40:25:32:0','iro':'irojyoGinnezu'},
	'色上黒':{'RGB16':'383c38','RGB10':'56:60:56','CMYK10':'78:70:72:40','iro':'irojyoBlack'},
	'クラフト（茶）色':{'RGB16':'fddd9c','RGB10':'253:221:156','CMYK10':'3:18:44:0','iro':'craftBrown'},
	'クラフト（濃茶）色':{'RGB16':'d3ab76','RGB10':'211:171:118','CMYK10':'22:37:56:0','iro':'craftDarkbrown'},
	'クラフト（白）色':{'RGB16':'ffffff','RGB10':'0:0:0','CMYK10':'0:0:0:0','iro':'craftWhite'},
	'ホワイト' :{'RGB16':'ffffff','RGB10':'0:0:0','CMYK10':'0:0:0:0','iro':'White'},
};

/**
  * 2014/11/27調べ　※今後変更の可能性があります。
  * http://www.dic-graphics.co.jp/cgi-bin/cs_result8.cgi
 **/
var dicColorNo='564';
var dicColorDictionary={
	'564':{'C':'0','M':'97','Y':'80','K':'0','iro':'紅赤'},
	'F240':{'C':'0','M':'100','Y':'100','K':'0','iro':'金赤'},
	'F28':{'C':'100','M':'54','Y':'0','K':'0','iro':'群青'},
	'222':{'C':'86','M':'70','Y':'0','K':'0','iro':'淡紫'},
	'255':{'C':'100','M':'85','Y':'28','K':'6','iro':'藍'},
	'N894':{'C':'100','M':'38','Y':'0','K':'61','iro':'濃藍'},
	'N899':{'C':'97','M':'100','Y':'38','K':'20','iro':'紺色'},
	'2397':{'C':'95','M':'88','Y':'44','K':'0','iro':'紺藍'},
	'131':{'C':'70','M':'0','Y':'76','K':'0','iro':'草'},
	'389':{'C':'94','M':'52','Y':'90','K':'26','iro':'濃草'},
	'2522':{'C':'0','M':'55','Y':'88','K':'0','iro':'オレンジ'},
	'238':{'C':'2','M':'71','Y':'100','K':'30','iro':'茶'},
	'N778':{'C':'66','M':'76','Y':'95','K':'52','iro':'焦茶'},
	'517':{'C':'28','M':'26','Y':'43','K':'0','iro':'ベージュ'},
	'542':{'C':'49','M':'39','Y':'46','K':'5','iro':'オリーブ'},
	'652':{'C':'45','M':'32','Y':'35','K':'0','iro':'淡鼡（ネズミ）'},
	'654':{'C':'64','M':'53','Y':'53','K':'10','iro':'鼡（ネズミ）'},
	'582':{'C':'85','M':'75','Y':'75','K':'90','iro':'墨(Ｆグロス85 100%)'},
}

/**
  * カラーをUIで選べるようにする
  * http://www.dic-graphics.co.jp/cgi-bin/cs_result8.cgi
 **/
var paperLst = new Array();
var colorLst = new Array();

for(var key in paperColorDictionary){
	paperLst.push(key);
}

for(var key in dicColorDictionary){
	colorLst.push(dicColorDictionary[key]['iro']+':Dic-'+key);
}

var dlg = new Window ('dialog', 'Enter Strings', [100,100,310,310]);
dlg.DrpDnLst = dlg.add ('dropdownlist', [30,25,180,40], paperLst);
dlg.DrpDnLst2 = dlg.add ('dropdownlist', [30,55,180,70], colorLst);
dlg.DrpDnLst.selection = 0;
dlg.DrpDnLst2.selection = 0;
dlg.submitBtn = dlg.add('button', [20,90,90,110], 'OK', {name:'ok'});
dlg.cancelBtn = dlg.add('button', [110,90,180,110], 'cancel', {name:'cancel'});
dlg.submitBtn.onClick = function (){getColor()};
dlg.show();

function getColor(){
	var arry = [];
	var  val = dlg.DrpDnLst2.selection.text;
	arry = val.split("-");
	dicColorNo=arry[1];
	cmykPaperColor=dlg.DrpDnLst.selection.text;
	main();
}

var sourceDoc;
function main(){
	try{
		// 選択されたファイルを変換  
		sourceDoc = app.activeDocument;
		changeColor(sourceDoc);  

		//pngで保存しておく
		var reg=/(.*)(?:\.([^.]+$))/;
		var savePngName = sourceDoc.path+'/'+sourceDoc.name.match(reg)[1]+'_'+paperColorDictionary[cmykPaperColor]['iro'] +'_dic'+dicColorNo+'.png';
		var exFile = new File(savePngName);
		sourceDoc.exportFile(exFile,ExportType.PNG24);
	}
	catch(err){
//		 alert(err);
	}
}

var paperCMYKColor = new CMYKColor();
var replaceColor;
var lockHash = {}; 
function changeColor(theDocument) {
   var docRef = theDocument;

	with(docRef) {
		if(documentColorSpace!=DocumentColorSpace.CMYK){
			alert('ドキュメントのカラーモードがRGBモードになっています。');
			return;
		}

		/**
		  * '当たり罫'レイヤーに紙色を設定する
		 **/
		var myRegexp =	/(\d+):(\d+):(\d+):(\d+)/;
		var match = myRegexp.exec( paperColorDictionary[cmykPaperColor]['CMYK10'] );
		paperCMYKColor.cyan = match[1];
		paperCMYKColor.magenta = match[2];
		paperCMYKColor.yellow = match[3];
		paperCMYKColor.black = match[4];

		//レイヤーのロックをはずす
		for( i=0; i<layers.length; i++ ){
			var layerName=layers[i].name;
			lockHash[layerName]=layers[i].locked;
			layers[i].locked = false;
		}

		//紙色をオブジェクトに設定
		try{
			var layer_atari=layers.getByName('当たり罫');
			changePaper(layer_atari);
		}
		catch(err) {
			alert('\'当たり罫\'レイヤーが見つかりません');
			reLock();
		}

		/**
		  * 'デザインレイヤー'にDic色を設定する
		  * Dicカラーガイドから直接値を取得のAPIがない?ので、
		  * 一旦スオッチにDicを登録して、それを読み出している
		 **/
		var spotName = 'Dic-'+dicColorNo+'_141127';
		if (!isColorExist(spotName)){
			try {  
				//c,m,y,kとcyan,magenta,yellow,blackの両方を設定すること
				var dicColor1 = new CMYKColor();  
				dicColor1.c = dicColorDictionary[dicColorNo]['C'];
				dicColor1.m = dicColorDictionary[dicColorNo]['M'];
				dicColor1.y = dicColorDictionary[dicColorNo]['Y'];
				dicColor1.k = dicColorDictionary[dicColorNo]['K'];
				dicColor1.cyan = dicColorDictionary[dicColorNo]['C'];
				dicColor1.magenta = dicColorDictionary[dicColorNo]['M'];
				dicColor1.yellow = dicColorDictionary[dicColorNo]['Y'];
				dicColor1.black = dicColorDictionary[dicColorNo]['K'];

				// スオッチに登録
				var spotColor1 = spots.add();
				spotColor1.name = spotName;
				spotColor1.colorType = ColorModel.SPOT;
				spotColor1.color = dicColor1;
			}  
			catch(err) {
				spotColor1.remove();
				reLock();
			}
		}

		//登録したDic色をスウォッチから色を読み出す
		replaceColor = swatches.getByName(spotName).color;

		//読み出したDic色をオブジェクトに設定
		 try{
			var layer_design=layers.getByName('デザインレイヤー');
			changeItem(layer_design);
		}
		catch(err) {
			alert('\'デザインレイヤー\'が見つかりません');
			reLock();
		}
		
		//レイヤーのロックを戻す
		reLock();
	}
}

/**
  * レイヤーのロックを戻す
 **/
function reLock(){
	for( i=0; i<sourceDoc.layers.length; i++ ){
		var layerName=sourceDoc.layers[i].name;
		if(lockHash[layerName]!=undefined){
			sourceDoc.layers[i].locked=lockHash[layerName];
		}
	} 
}

/**
  * オブジェクトの色を変更する再帰関数。
  * パスオブジェクト、複合パスオブジェクトの色を
  * 指定したCMYKに変える仕様
 **/
var originalPaperColor;
function changePaper(target){
	var f = false;
	var tint = 100;

	//グループを検索
	for(var i=0;i<target.groupItems.length;i++){
		var item = target.groupItems[i];
		changePaper(item);
	};
	//パスを検索
	for(var i=0;i<target.pathItems.length;i++){
		var pitem = target.pathItems[i];
         originalPaperColor =  setCMYKColor(pitem.fillColor.cyan,pitem.fillColor.magenta,pitem.fillColor.yellow,pitem.fillColor.black);
		pitem.fillColor = paperCMYKColor;
	}

	//複合パスを検索
	for(var i=0;i<target.compoundPathItems.length;i++){
		var cpitem = target.compoundPathItems[i];
		for(var j=0;j<cpitem.pathItems.length;j++){
			var pitem2 = cpitem.pathItems[j];
              originalPaperColor =  setCMYKColor(pitem2.fillColor.cyan,pitem2.fillColor.magenta,pitem2.fillColor.yellow,pitem2.fillColor.black);
			pitem2.filled = true; 
			pitem2.fillColor = paperCMYKColor;
		}
	}
}

// CMYK カラーを設定し、CMYK カラーオブジェクトを返す
function setCMYKColor(c,m,y,k){
    var CMYK = new CMYKColor();
    CMYK.cyan = c;
    CMYK.magenta = m;
    CMYK.yellow = y;
    CMYK.black = k;
    return CMYK;
}

/**
  * オブジェクトの色を変更する再帰関数。
  * パスオブジェクトと複合パスオブジェクト、
  * テキストオブジェクトの色を指定したDicに変える仕様
  * tint:特色の場合の%
 **/
function changeItem(target){
	var f = false;
	var tint = 100;
	
	//グループを検索
	for(var i=0;i<target.groupItems.length;i++){
		var item = target.groupItems[i];
		changeItem(item);
	}

	//パスを検索
	for(var i=0;i<target.pathItems.length;i++){
		var pitem = target.pathItems[i];
		if(pitem.stroked!=false){//線
			if(pitem.strokeColor.typename == "SpotColor"){//特色の場合は%を引き継ぐ
				tint = pitem.strokeColor.tint;
				pitem.strokeColor = replaceColor;
				pitem.strokeColor.tint = tint;
			}else if(pitem.strokeColor.typename == "CMYKColor"){//CMYKカラーの場合
	   		if(!isWhite(pitem.position,pitem.strokeColor) ){
					pitem.strokeColor = replaceColor;
				}else{//白なら封筒色に合わせる処理を入れる
					pitem.strokeColor = paperCMYKColor;
				}
			}
		}
		if(pitem.filled !=false){//塗り
			if(pitem.fillColor.typename == "SpotColor"){//特色の場合は%を引き継ぐ
				tint = pitem.fillColor.tint;
				pitem.fillColor = replaceColor;
				pitem.fillColor.tint = tint;
			}else if(pitem.fillColor.typename == "CMYKColor"){//CMYKカラーの場合
	   		if(!isWhite(pitem.position,pitem.fillColor) ){
					pitem.fillColor = replaceColor;
				}else{//白なら封筒色に合わせる処理を入れる
					pitem.fillColor = paperCMYKColor;
				}
			}
		}
	}

	//複合パスを検索
	for(var i=0;i<target.compoundPathItems.length;i++){
		var cpitem = target.compoundPathItems[i];
		for(var j=0;j<cpitem.pathItems.length;j++){
			var pitem2 = cpitem.pathItems[j];
			if(pitem2.stroked!=false){//線
				 if(pitem2.strokeColor.typename == "SpotColor"){//特色の場合は%を引き継ぐ
					tint = pitem.strokeColor.tint;
					pitem2.strokeColor = replaceColor;
					pitem2.strokeColor.tint = tint;
				}else if(pitem2.strokeColor.typename == "CMYKColor"){//CMYKカラーの場合
					if(!isWhite(pitem2.position,pitem2.strokeColor) ){
						pitem2.strokeColor = replaceColor;
					}else{//白なら封筒色に合わせる処理を入れる
						pitem2.strokeColor = paperCMYKColor;
					}
				}
			}
			if(pitem2.filled !=false){//塗り
				if(pitem2.fillColor.typename == "SpotColor"){//特色の場合は%を引き継ぐ
					tint = pitem2.fillColor.tint;
					pitem2.fillColor = replaceColor;
					pitem2.fillColor.tint = tint;
				}else if(pitem2.fillColor.typename == "CMYKColor"){//CMYKカラーの場合
					if(!isWhite(pitem2.position,pitem2.fillColor) ){
						pitem2.fillColor = replaceColor;
					}else{//白なら封筒色に合わせる処理を入れる
						pitem2.fillColor = paperCMYKColor;
					}
				}
			}
		}
	}
	
	//テキストを検索
	for(var k=0;k<target.textFrames.length;k++){
		var titem = target.textFrames[k];
		var text = titem.textRange;
		//文字色が白の時は変更しない
		if(!isWhite(titem.position,text.fillColor) ){
			tint = text.fillColor.tint;
			text.fillColor = replaceColor;
			if(tint){//特色%
				text.fillColor.tint = tint;
			}
		}else{//白なら封筒色に合わせる処理を入れる
			text.fillColor = paperCMYKColor;
		}
	}
}

var whiteLst = new Array();
function isWhite(position,color){
	if(hasWhite(position)){
		return true;
	}
    //白色、または、封筒色と同じ場合
	if((color.cyan==0 && color.magenta==0 && color.yellow==0 && color.black== 0) ||
        (color.cyan==originalPaperColor.cyan && color.magenta==originalPaperColor.magenta && color.yellow==originalPaperColor.yellow && color.black==originalPaperColor.black)){
		whiteLst.push(position);
		return true;
	}
	return false;
}

// リストにあるか検索
function hasWhite(position){
	var flg = false;
	for(var i=0; i<whiteLst.length; i++) {
		if(whiteLst[i][0]==position[0] && whiteLst[i][1]==position[1] ){
			flg = true; break;
		}
	}
	return flg;
}

function isColorExist(colorName){
	var clrs = app.activeDocument.swatches;
	for (var i=0;i<clrs.length;i++){
		if (clrs[i].name==colorName){
			return true;
		}
	}
	return false;
}
